// rand-ngon-naive.cpp
// MCS 481 project 2 description version 1.0
#include <iostream>
#include <cstdlib>
#include <CGAL/Exact_predicates_inexact_constructions_kernel.h>
#include <CGAL/Polygon_2.h>

typedef CGAL::Exact_predicates_inexact_constructions_kernel K;
typedef K::Point_2 Point;
typedef CGAL::Polygon_2<K> Polygon;
typedef Polygon::Vertex_iterator VertexIterator;

using namespace std;

double dblrand()  // pseudorandom double in [0.0,1.0).
{
  return rand()/(double(RAND_MAX) + 1);
}

int main(int argc, char *argv[])
{
  Polygon pgn;
  int nv = 5;  // Default number of vertices

  // First command-line argument is number of verices
  if (argc > 1)
    nv = atoi(argv[1]);

  srand((unsigned)time(0)); // Seed the random generator with current time

  // Generate random sequences of points until the result is a simple polygon
  int n = 0;
  do {
    pgn.clear();
    for (int i=0; i<nv; i++) {
      Point p(2.0*dblrand()-1.0, 2.0*dblrand()-1.0);
      pgn.push_back(p);
    }
    n++;
  } while (!pgn.is_simple());

  // Uncomment next two lines to print number of iterations
  // cout << "Required " << n << " attempts to generate a simple " 
  //     << nv << "-gon." << endl;

  // Make counterclockwise, for consistency
  if (!pgn.is_counterclockwise_oriented())
    pgn.reverse_orientation();

  // Print the vertices
  for (VertexIterator vi = pgn.vertices_begin(); vi != pgn.vertices_end(); ++vi) {
    cout << *vi << endl;
  }
  return 0;
}
